## START: Set by rpmautospec
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global srcname engineio

Name:           python-%{srcname}
Version:        4.2.1
Release:        %autorelease
Summary:        Python Engine.IO server and client

License:        MIT
URL:            https://github.com/miguelgrinberg/%{name}/
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildArch:      noarch
 
BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros

# Documentation
BuildRequires:  make
BuildRequires:  python3dist(sphinx)

%global common_description %{expand:
Engine.IO is a lightweight transport protocol that enables real-time
bidirectional event-based communication between clients (typically, though not
always, web browsers) and a server. The official implementations of the client
and server components are written in JavaScript. This package provides Python
implementations of both, each with standard and asyncio variants.}

%description %{common_description}


%package -n     python3-%{srcname}
Summary:        %{summary}

%description -n python3-%{srcname} %{common_description}


%pyproject_extras_subpkg -n python3-%{srcname} client asyncio_client


%package        doc
Summary:        Documentation for %{name}

%description    doc %{common_description}


%prep
%autosetup -p1

# Remove pre-compiled/pre-minified browser build of
# https://github.com/socketio/engine.io from the examples. This makes them less
# useful, but satisfies
# https://docs.fedoraproject.org/en-US/packaging-guidelines/JavaScript/ and
# https://docs.fedoraproject.org/en-US/packaging-guidelines/#bundling. It
# doesn’t seem worth it to package the JavaScript implementation of Engine.IO
# just for the sake of these examples.
find examples -type f -name 'engine.io.js' -print -delete


%generate_buildrequires
%pyproject_buildrequires -x client,asyncio_client -t


%build
%pyproject_wheel
PYTHONPATH="${PWD}" %make_build -C docs html SPHINXOPTS='%{?_smp_mflags}'
rm -vf docs/_build/html/.buildinfo


%install
%pyproject_install
%pyproject_save_files %{srcname}


%check
%pytest


%files -n python3-%{srcname} -f %{pyproject_files}
%license LICENSE


%files doc
%license LICENSE
%doc CHANGES.md
%doc README.md
%doc SECURITY.md
%doc docs/_build/html
# Bundled pre-compiled engine.io.js has been removed:
%doc examples


%changelog
* Mon Aug 02 2021 Benjamin A. Beasley <code@musicinmybrain.net> 4.2.1-1
- Update to 4.2.1 (fixes RHBZ#1989114)

* Tue Jul 27 2021 Benjamin A. Beasley <code@musicinmybrain.net> 4.2.0-3
- Move %generate_buildrequires after %prep to make the spec file easier to
  follow

* Wed Jul 21 2021 Benjamin A. Beasley <code@musicinmybrain.net> 4.2.0-2
- No longer skip any tests

* Wed Jul 21 2021 Benjamin A. Beasley <code@musicinmybrain.net> 4.2.0-1
- Update to 4.2.0 (closes RHBZ#1978267)

* Sun Jul 04 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.14.2-2
- Fix typos in script to remove executable permissions from files without
  shebangs

* Sun Jul 04 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.13.1-1
- Update to 3.14.2 (last 3.x release)
- Drop python-engineio-3.13.1-all-tasks.patch, now upstream
- Fix spurious executable permissions (upstream PR#240)
- Remove .buildinfo file from HTML documentation

* Thu Jul 01 2021 Benjamin A. Beasley <code@musicinmybrain.net> - 3.13.1-5
- Near-total spec file rewrite
- Removed obsolete practices like python_provide macro and manual Requires
- Added documentation and tests

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 3.13.1-4
- Rebuilt for Python 3.10

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.13.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Aug 09 2020 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 3.13.2-1
- Disable tests temporarily (fixes FTBFS)

* Tue Aug 04 2020 Mukundan Ragavan <nonamedotc@fedoraproject.org> - 3.13.1-1
- Update to 3.13.1

* Sat Aug 01 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.11.1-6
- Second attempt - Rebuilt for
  https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.11.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue May 26 2020 Miro Hrončok <mhroncok@redhat.com> - 3.11.1-4
- Rebuilt for Python 3.9

* Thu Jan 30 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.11.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Mon Dec 30 2019 Mukundan Ragavan <nonamedotc@gmail.com> - 3.11.1-2
- Use expand macro for description

* Sun Dec 22 2019 Mukundan Ragavan <nonamedotc@gmail.com> - 3.11.1-1
- Initial package.

